// 解决 IE 11 兼容性问题
import 'babel-polyfill';

import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import { Markdown } from 'react-markdown-reader';
import CodeView from 'react-code-view';
import { findDOMNode } from 'react-dom';
import { Button, FormControl, IconFont } from 'rsuite';
import { PageContainer } from 'rsuite-docs';


import './less/index.less';
import AutoComplete from '../src/main';

class App extends Component {
  render() {
    return (
      <PageContainer
        activeKey="Autocomplete"
        githubURL="https://github.com/rsuite/rsuite-autocomplete"
      >
        <Markdown>{require('../README.md')}</Markdown>

        <CodeView
          dependencies={{
            React,
            AutoComplete
          }}
        >
          {require('./md/basic.md')}
        </CodeView>

        <CodeView
          dependencies={{
            React,
            AutoComplete
          }}
        >
          {require('./md/customized.md')}
        </CodeView>

        <Markdown>{require('./md/props.md')}</Markdown>
      </PageContainer>
    );
  }
}

ReactDOM.render(<App />,
  document.getElementById('app')
);
