### 自定义选项
你也可以传递 `AutoComplete.Item` 作为 `AutoComplete` 的 `children`，而非使用 `dataSource`。
<!--start-code-->
```js
const Item = AutoComplete.Item;

class CustomizedAutoComplete extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      result: []
    };
  }
  render() {
    const { result } = this.state;
    const children = result.map((email, i) => {
      return <Item text={email} key={i} onClick={(text)=>{
        console.log(text,i);
      }}>{email}</Item>;
    });
    return (
      <AutoComplete
        onSelect={(data) => {
          console.log(data);
        }}
        onChange={(value) => {
          let result;
          if (!value || value.indexOf('@') >= 0) {
            result = [];
          } else {
            result = ['hypers.com', 'hypers.com.cn', 'hypers.cc'].map(domain => `${value}@${domain}`);
          }
          this.setState({ result });
        }}
        placeholder="Email"
      >
        {children}
      </AutoComplete>
    );
  }
}

ReactDOM.render(<CustomizedAutoComplete />);
```
<!--end-code-->
