'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _rsuite = require('rsuite');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _domLib = require('dom-lib');

var _omit2 = require('lodash/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _AutoCompleteItem = require('./AutoCompleteItem');

var _AutoCompleteItem2 = _interopRequireDefault(_AutoCompleteItem);

var _moveFocus = require('../utils/moveFocus');

var _getItemsAndActiveIndex = require('../utils/getItemsAndActiveIndex');

var _getItemsAndActiveIndex2 = _interopRequireDefault(_getItemsAndActiveIndex);

var _KEY_CODE = require('../KEY_CODE');

var _KEY_CODE2 = _interopRequireDefault(_KEY_CODE);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  placeholder: _propTypes2.default.string,
  dataSource: _propTypes2.default.arrayOf(_propTypes2.default.string),
  disabled: _propTypes2.default.bool,
  onSelect: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  value: _propTypes2.default.string,
  defaultValue: _propTypes2.default.string
}; /* eslint-disable react/no-find-dom-node */


var defaultProps = {
  dataSource: []
};

var AutoComplete = function (_Component) {
  (0, _inherits3.default)(AutoComplete, _Component);

  function AutoComplete(props) {
    (0, _classCallCheck3.default)(this, AutoComplete);

    var _this = (0, _possibleConstructorReturn3.default)(this, (AutoComplete.__proto__ || (0, _getPrototypeOf2.default)(AutoComplete)).call(this, props));

    _this.getHandleCustomizedItemClick = function (item) {
      return function () {
        var _item$props;

        _this.handleItemChange.apply(_this, arguments);
        item && item.props && item.props.onClick && (_item$props = item.props).onClick.apply(_item$props, arguments);
      };
    };

    _this.handleSearchData = function (value) {
      var dataSource = _this.props.dataSource;

      var valueUpper = value.trim().toUpperCase();
      var children = valueUpper.length > 0 ? dataSource.filter(function (data) {
        var text = data.toUpperCase();
        return text.indexOf(valueUpper) > -1;
      }) : [];
      _this.setState({
        text: value,
        children: children
      });
    };

    _this.handleChange = function (value) {
      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var onChange = _this.props.onChange;

      _this.handleSearchData(value);
      onChange && onChange.apply(undefined, [value].concat(args));
    };

    _this.handleInputFocus = function (e) {
      _this.setState({
        show: true
      });
      _this.handleSearchData(e.target.value);
      _this.bindAutoClosePanelFunctionToDom();
    };

    _this.handleItemChange = function (text) {
      for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      var onSelect = _this.props.onSelect;

      _this.setState({
        text: text,
        children: [],
        show: false
      });
      onSelect && onSelect.apply(undefined, [text].concat(args));
    };

    _this.handleKeyDown = function (event) {
      switch (event.keyCode) {
        case _KEY_CODE2.default.DOWN:
          event.preventDefault();
          (0, _moveFocus.focusNextItem)((0, _getItemsAndActiveIndex2.default)(_this.getFocusableItems()));
          break;
        case _KEY_CODE2.default.ESC:
        case _KEY_CODE2.default.TAB:
          _this.handleClose(event);
          _this.unBindAutoClosePanelFunctionToDom();
          break;
        default:
      }
    };

    _this.handleClose = function () {
      _this.setState({
        show: false,
        children: []
      });
    };

    _this.handleDomClosePanel = function (e) {
      var node = (0, _reactDom.findDOMNode)(_this);
      var input = (0, _reactDom.findDOMNode)(_this.input);
      if (e.target !== node && !(0, _domLib.contains)(node, e.target)) {
        _this.handleClose();
      }
      if (e.target !== input) {
        _this.unBindAutoClosePanelFunctionToDom();
      }
    };

    _this.bindInput = function (ref) {
      _this.input = ref;
    };

    _this.state = {
      children: [],
      show: true,
      text: _this.props.value || _this.props.defaultValue || ''
    };
    return _this;
  }

  (0, _createClass3.default)(AutoComplete, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var children = this.props.children;

      if (children) {
        this.setState({
          children: children
        });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var children = nextProps.children,
          value = nextProps.value;

      if (children && this.state.children !== children) {
        this.setState({
          children: children
        });
      }

      if (this.props.value !== value) {
        this.setState({
          text: value
        });
      }
    }
  }, {
    key: 'getFocusableItems',
    value: function getFocusableItems() {
      var node = (0, _reactDom.findDOMNode)(this);
      return (0, _from2.default)(node.querySelectorAll('.auto-complete-item'));
    }
  }, {
    key: 'getItemsProps',
    value: function getItemsProps(item) {
      return {
        onClick: this.getHandleCustomizedItemClick(item),
        onClose: this.handleClose
      };
    }
  }, {
    key: 'getDefaltItems',
    value: function getDefaltItems() {
      var _this2 = this;

      var _state = this.state,
          children = _state.children,
          text = _state.text;

      return children.map(function (data, key) {
        var active = text === data;
        var props = (0, _assign2.default)({
          key: key,
          active: active,
          text: data
        }, _this2.getItemsProps());
        return _react2.default.createElement(_AutoCompleteItem2.default, props);
      });
    }
  }, {
    key: 'getCustomizedItems',
    value: function getCustomizedItems() {
      var _this3 = this;

      return _react2.default.Children.map(this.state.children, function (item) {
        return (0, _react.cloneElement)(item, _this3.getItemsProps(item));
      });
    }
  }, {
    key: 'bindAutoClosePanelFunctionToDom',
    value: function bindAutoClosePanelFunctionToDom() {
      (0, _domLib.on)(document.body, 'click', this.handleDomClosePanel);
    }
  }, {
    key: 'unBindAutoClosePanelFunctionToDom',
    value: function unBindAutoClosePanelFunctionToDom() {
      (0, _domLib.off)(document.body, 'click', this.handleDomClosePanel);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          disabled = _props.disabled,
          placeholder = _props.placeholder,
          className = _props.className,
          children = _props.children;

      var props = (0, _omit3.default)(this.props, [].concat((0, _toConsumableArray3.default)((0, _keys2.default)(propTypes)), ['children']));
      var _state2 = this.state,
          text = _state2.text,
          show = _state2.show;

      var childrenDoms = children ? this.getCustomizedItems() : this.getDefaltItems();
      var contentClassName = (0, _classnames2.default)('auto-complete-content', { show: show && childrenDoms.length > 0 });
      return _react2.default.createElement(
        'div',
        { className: (className || '') + ' auto-complete-wrap' },
        _react2.default.createElement(_rsuite.FormControl, (0, _extends3.default)({}, props, {
          ref: this.bindInput,
          type: 'text',
          placeholder: placeholder,
          disabled: disabled,
          value: text,
          onFocus: this.handleInputFocus,
          onChange: this.handleChange,
          onKeyDown: this.handleKeyDown
        })),
        _react2.default.createElement(
          'div',
          {
            className: contentClassName
          },
          _react2.default.createElement(
            'ul',
            null,
            childrenDoms
          )
        )
      );
    }
  }]);
  return AutoComplete;
}(_react.Component);

AutoComplete.propTypes = propTypes;
AutoComplete.defaultProps = defaultProps;
AutoComplete.Item = _AutoCompleteItem2.default;

exports.default = AutoComplete;