'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactDom = require('react-dom');

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _moveFocus = require('../utils/moveFocus');

var _getItemsAndActiveIndex = require('../utils/getItemsAndActiveIndex');

var _getItemsAndActiveIndex2 = _interopRequireDefault(_getItemsAndActiveIndex);

var _KEY_CODE = require('../KEY_CODE');

var _KEY_CODE2 = _interopRequireDefault(_KEY_CODE);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable react/no-find-dom-node,jsx-a11y/no-noninteractive-element-interactions */
var propTypes = {
  text: _propTypes2.default.string,
  title: _propTypes2.default.string,
  active: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  onClose: _propTypes2.default.func,
  onKeyDown: _propTypes2.default.func
};

var AutoCompleteItem = function (_Component) {
  (0, _inherits3.default)(AutoCompleteItem, _Component);

  function AutoCompleteItem() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AutoCompleteItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AutoCompleteItem.__proto__ || (0, _getPrototypeOf2.default)(AutoCompleteItem)).call.apply(_ref, [this].concat(args))), _this), _this.handleClick = function (event) {
      var _this$props = _this.props,
          text = _this$props.text,
          onClick = _this$props.onClick;

      onClick && onClick(text, event);
    }, _this.handleClose = function (event) {
      var onClose = _this.props.onClose;

      onClose && onClose(event);
    }, _this.handleKeyDown = function (event) {
      var onKeyDown = _this.props.onKeyDown;

      switch (event.keyCode) {
        case _KEY_CODE2.default.DOWN:
          (0, _moveFocus.focusNextItem)((0, _getItemsAndActiveIndex2.default)(_this.getFocusAbleItems()));
          event.preventDefault();
          break;
        case _KEY_CODE2.default.UP:
          (0, _moveFocus.focusPreviousItem)((0, _getItemsAndActiveIndex2.default)(_this.getFocusAbleItems()));
          event.preventDefault();
          break;
        case _KEY_CODE2.default.ENTER:
          _this.handleClick(event);
          break;
        case _KEY_CODE2.default.ESC:
        case _KEY_CODE2.default.TAB:
          _this.handleClose(event);
          break;
        default:
      }
      onKeyDown && onKeyDown(event);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AutoCompleteItem, [{
    key: 'getFocusAbleItems',
    value: function getFocusAbleItems() {
      var node = (0, _reactDom.findDOMNode)(this);
      if (!node) {
        return [];
      }
      return (0, _from2.default)(node.parentNode.querySelectorAll('.auto-complete-item'));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          active = _props.active,
          text = _props.text;

      var props = (0, _omit2.default)(this.props, (0, _keys2.default)(propTypes));
      var className = (0, _classnames2.default)('item auto-complete-item', {
        active: active
      });
      var children = this.props.children ? this.props.children : text;
      var title = !children ? this.props.title || text : '';
      return _react2.default.createElement(
        'li',
        (0, _extends3.default)({
          title: title,
          className: className,
          onClick: this.handleClick,
          onKeyDown: this.handleKeyDown,
          tabIndex: '-1'
        }, props),
        _react2.default.createElement(
          'label',
          { className: 'text' },
          children
        )
      );
    }
  }]);
  return AutoCompleteItem;
}(_react.Component);

AutoCompleteItem.propTypes = propTypes;

exports.default = AutoCompleteItem;