"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var getHandleFocusMethod = function getHandleFocusMethod(calcIndex) {
  return function () {
    var itemsAndActiveIndex = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var children = itemsAndActiveIndex.children,
        activeIndex = itemsAndActiveIndex.activeIndex;

    if (children.length === 0) {
      return;
    }
    var index = calcIndex(activeIndex, children);
    children[index] && children[index].focus();
  };
};

var calcNextIndex = function calcNextIndex(activeIndex, children) {
  return activeIndex === children.length - 1 ? 0 : activeIndex + 1;
};
var calcPreviousIndex = function calcPreviousIndex(activeIndex, children) {
  return activeIndex === 0 ? children.length - 1 : activeIndex - 1;
};

var focusNextItem = getHandleFocusMethod(calcNextIndex);
var focusPreviousItem = getHandleFocusMethod(calcPreviousIndex);

exports.focusNextItem = focusNextItem;
exports.focusPreviousItem = focusPreviousItem;